Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.web.servlet.view
Class AbstractCachingViewResolver

    java.lang.Object
      org.springframework.context.support.ApplicationObjectSupport
          org.springframework.web.context.support.WebApplicationObjectSupport
              org.springframework.web.servlet.view.AbstractCachingViewResolver

All Implemented Interfaces:
  Aware, ApplicationContextAware, ServletContextAware, ViewResolver

Direct Known Subclasses:
  ResourceBundleViewResolver, UrlBasedViewResolver, XmlViewResolver

    public abstract class AbstractCachingViewResolver

extends WebApplicationObjectSupport
implements ViewResolver

Convenient base class for `ViewResolver` implementations. Caches `View` objects once resolved: This means that view resolution won't be a performance problem, no matter how costly initial view retrieval is.

Subclasses need to implement the `loadView(java.lang.String, java.util.Locale)` template method, building the View object for a specific view name and locale.

Author:
  Rod Johnson, Juergen Hoeller
See Also:
  `loadView(java.lang.String, java.util.Locale)`

Field Summary

Fields inherited from class org.springframework.context.support.ApplicationObjectSupport
`logger`

Constructor Summary
`AbstractCachingViewResolver()`

Method Summary
`void` | `clearCache()` Clear the entire view cache, removing all cached view objects.
`protected View` | `createView(java.lang.String viewName, java.util.Locale locale)` Create the actual View object.
`protected java.lang.Object` | `getCacheKey(java.lang.String viewName, java.util.Locale locale)` Return the cache key for the given view name and the given locale.
`boolean` | `isCache()` Return if caching is enabled.
`boolean` | `isCacheUnresolved()` Return if caching of unresolved views is enabled.
`protected abstract View` | `loadView(java.lang.String viewName, java.util.Locale locale)` Subclasses must implement this method, building a View object for the specified view.
`void` | `removeFromCache(java.lang.String viewName, java.util.Locale locale)` Provides functionality to clear the cache for a certain view.
`View` | `resolveViewName(java.lang.String viewName, java.util.Locale locale)` Resolve the given view by name.
`void` | `setCache(boolean cache)` Enable or disable caching.
`void` | `setCacheUnresolved(boolean cacheUnresolved)` Whether a view name once resolved to `null` should be cached and automatically resolved to `null` subsequently.

Methods inherited from class org.springframework.web.context.support.WebApplicationObjectSupport
`getServletContext, getTempDir, getWebApplicationContext, initApplicationContext, initServletContext, isContextRequired, setServletContext`

Methods inherited from class org.springframework.context.support.ApplicationObjectSupport
`getApplicationContext, getMessageSourceAccessor, initApplicationContext, requiredContextClass, setApplicationContext`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### AbstractCachingViewResolver

    public AbstractCachingViewResolver()

Method Detail

### setCache

    public void setCache(boolean cache)

  Enable or disable caching.

  Default is "true": caching is enabled. Disable this only for debugging and development.

  Warning: Disabling caching can severely impact performance.

### isCache

    public boolean isCache()

  Return if caching is enabled.

### setCacheUnresolved

    public void setCacheUnresolved(boolean cacheUnresolved)

  Whether a view name once resolved to `null` should be cached and automatically resolved to `null` subsequently.

  Default is "true": unresolved view names are being cached, as of Spring 3.1. Note that this flag only applies if the general `"cache"` flag is kept at its default of "true" as well.

  Of specific interest is the ability for some AbstractUrlBasedView implementations (FreeMarker, Velocity, Tiles) to check if an underlying resource exists via `AbstractUrlBasedView.checkResource(Locale)`. With this flag set to "false", an underlying resource that re-appears is noticed and used. With the flag set to "true", one check is made only.

### isCacheUnresolved

    public boolean isCacheUnresolved()

  Return if caching of unresolved views is enabled.

### resolveViewName

    public View resolveViewName(java.lang.String viewName,
                                java.util.Locale locale)
                         throws java.lang.Exception

  Description copied from interface: `ViewResolver`
  Resolve the given view by name.

  Note: To allow for ViewResolver chaining, a ViewResolver should return `null` if a view with the given name is not defined in it. However, this is not required: Some ViewResolvers will always attempt to build View objects with the given name, unable to return `null` (rather throwing an exception when View creation failed).

  Specified by:
    `resolveViewName` in interface `ViewResolver`
  Parameters:
    `viewName` - name of the view to resolve
    `locale` - Locale in which to resolve the view. ViewResolvers that support internationalization should respect this.
  Returns:
    the View object, or `null` if not found (optional, to allow for ViewResolver chaining)
  Throws:
    `java.lang.Exception` - if the view cannot be resolved (typically in case of problems creating an actual View object)

### getCacheKey

    protected java.lang.Object getCacheKey(java.lang.String viewName,
                                           java.util.Locale locale)

  Return the cache key for the given view name and the given locale.

  Default is a String consisting of view name and locale suffix. Can be overridden in subclasses.

  Needs to respect the locale in general, as a different locale can lead to a different view resource.

### removeFromCache

    public void removeFromCache(java.lang.String viewName,
                                java.util.Locale locale)

  Provides functionality to clear the cache for a certain view.

  This can be handy in case developer are able to modify views (e.g. Velocity templates) at runtime after which you'd need to clear the cache for the specified view.

  Parameters:
    `viewName` - the view name for which the cached view object (if any) needs to be removed
    `locale` - the locale for which the view object should be removed

### clearCache

    public void clearCache()

  Clear the entire view cache, removing all cached view objects. Subsequent resolve calls will lead to recreation of demanded view objects.

### createView

    protected View createView(java.lang.String viewName,
                              java.util.Locale locale)
                       throws java.lang.Exception

  Create the actual View object.

  The default implementation delegates to `loadView(java.lang.String, java.util.Locale)`. This can be overridden to resolve certain view names in a special fashion, before delegating to the actual `loadView` implementation provided by the subclass.

  Parameters:
    `viewName` - the name of the view to retrieve
    `locale` - the Locale to retrieve the view for
  Returns:
    the View instance, or `null` if not found (optional, to allow for ViewResolver chaining)
  Throws:
    `java.lang.Exception` - if the view couldn't be resolved
  See Also:
    `loadView(java.lang.String, java.util.Locale)`

### loadView

    protected abstract View loadView(java.lang.String viewName,
                                     java.util.Locale locale)
                              throws java.lang.Exception

  Subclasses must implement this method, building a View object for the specified view. The returned View objects will be cached by this ViewResolver base class.

  Subclasses are not forced to support internationalization: A subclass that does not may simply ignore the locale parameter.

  Parameters:
    `viewName` - the name of the view to retrieve
    `locale` - the Locale to retrieve the view for
  Returns:
    the View instance, or `null` if not found (optional, to allow for ViewResolver chaining)
  Throws:
    `java.lang.Exception` - if the view couldn't be resolved
  See Also:
    `resolveViewName(java.lang.String, java.util.Locale)`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD